<template>
  <div class="container-essence">
    <el-card>
      <div class="top-box">
        <div class="top-container">
          <el-select placeholder="行业" clearable v-model="industry" @change="conditionChange" style="margin-bottom: 20px">
            <el-option v-for="item in chartPermissionList" :label="item.PermissionName" :key="item.ChartPermissionId" :value="item.ChartPermissionId"></el-option>
          </el-select>
          <el-select placeholder="发布状态" clearable v-model="status" @change="conditionChange" style="margin-bottom: 20px">
            <el-option v-for="item in options" :key="item.id" :label="item.name" :value="item.id"></el-option>
          </el-select>
          <date-picker v-model="issueTime" type="date" range placeholder="发布时间" value-type="format" @change="conditionChange"> </date-picker>
          <div class="top-input">
            <el-input @input="keyValueInpt" v-model="keyWord" placeholder="请输入报告标题" clearable style="display: inline-block">
              <i slot="prefix" class="el-input__icon el-icon-search"></i>
            </el-input>
          </div>
        </div>
        <div>
          <el-button type="primary" @click="$router.push('/addRoadshow')">添加</el-button>
        </div>
      </div>
      <el-table :data="tableData" style="width: 100%" border>
        <el-table-column prop="" align="center" label="标题" min-width="260">
          <template slot-scope="scope">
            <span class="editsty" @click="goDetail(scope.row)">{{ scope.row.Title }}</span>
          </template>
        </el-table-column>
        <el-table-column prop="Periods" align="center" label="期数" width="108"></el-table-column>
        <el-table-column prop="PublishDate" align="center" label="发布时间" min-width="160"></el-table-column>
        <el-table-column prop="LastUpdatedTime" align="center" label="更新时间" min-width="160"></el-table-column>
        <el-table-column align="center" label="发布状态" min-width="108">
          <template slot-scope="scope">
            {{ scope.row.PublishStatus == 1 ? "已发布" : "未发布" }}
          </template>
        </el-table-column>
        <el-table-column width="135" label="PV / UV" align="center" :render-header="renderHeader">
          <template slot-scope="scope">
            <div class="pv-uv-download">
              <span>{{ scope.row.Pv }}/{{ scope.row.Uv }}</span>
              <a :href="exportPvUv(scope.row.ArticleId)" download>
                <img src="~@/assets/img/rai_m/pvuv_download.png" alt="" />
              </a>
            </div>
          </template>
        </el-table-column>
        <el-table-column align="center" label="操作" min-width="165">
          <template slot-scope="scope">
            <span v-if="scope.row.PublishStatus !== 1" class="editsty" @click="operationBtn(scope.row.ArticleId, '发布')">发布&nbsp;&nbsp;</span>
            <span v-else class="editsty" @click="operationBtn(scope.row.ArticleId, '取消发布')">取消发布&nbsp;&nbsp;</span>
            <span class="editsty" @click="editReport(scope.row.ArticleId)">编辑&nbsp;&nbsp;</span>
            <span v-if="scope.row.PublishStatus !== 1 && !scope.row.Periods" class="deletesty" @click="operationBtn(scope.row.ArticleId, '删除')">删除</span>
          </template>
        </el-table-column>
      </el-table>
      <!-- 分页 -->
      <el-col :span="24" class="toolbar">
        <m-page :total="total" :page_no="page_no" :pageSize="10" @handleCurrentChange="handleCurrentChange" />
      </el-col>
    </el-card>
  </div>
</template>

<script>
import mPage from "@/components/mPage.vue";
import { raiInterface } from "@/api/api.js";
export default {
  name: "",
  components: { mPage },
  props: {},
  data() {
    return {
      page_no: sessionStorage.getItem("roadshowEssenceBack") ? JSON.parse(sessionStorage.getItem("roadshowEssenceBack")).page_no : 1,
      total: 0, //条数
      PageSize: 10, //每页显示几条
      industry: "", //行业
      status: "", //发布状态
      issueTime: "", //时间
      chartPermissionList: [], //行业的数组
      options: [
        { id: 0, name: "未发布" },
        { id: 1, name: "已发布" },
      ], //发布的数组
      tableData: [], //表格
      keyWord: "",
    };
  },
  computed: {
    sta() {
      return this.status === 0 ? this.status : this.status === 1 ? this.status : 2;
    },
  },
  watch: {},
  created() {},
  mounted() {
    if (sessionStorage.getItem("roadshowEssenceBack")) {
      const initialize = JSON.parse(sessionStorage.getItem("roadshowEssenceBack"));
      this.status = initialize.status;
      this.issueTime = initialize.issueTime;
      this.industry = initialize.industry;
      this.keyWord = initialize.keyWord;
    }
    this.getList();
    this.getIndustryList();
  },
  methods: {
    //获取list数组
    async getList() {
      const res = await raiInterface.roadshowEssenceList({
        CurrentIndex: this.page_no,
        PageSize: this.PageSize,
        PublishStatus: this.sta - 0,
        ChartPermissionId: this.industry,
        StartDate: this.issueTime[0],
        EndDate: this.issueTime[1],
        KeyWord: this.keyWord,
      });
      if (res.Ret === 200) {
        this.tableData = res.Data.List;
        this.total = res.Data.Paging.Totals;
      }
    },
    //获取行业
    async getIndustryList() {
      const res = await raiInterface.chartPermissionFirstHaveIco();
      if (res.Ret === 200) {
        this.chartPermissionList = res.Data.List;
      }
    },
    //选择后的事件
    conditionChange() {
      this.page_no = 1;
      this.getList();
    },
    //发布，取消发布，删除
    operationBtn(id, value) {
      this.$confirm(`确定${value}该文章吗？`, "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          if (value == "删除") {
            const res = await raiInterface.roadshowEssenceDelete({ ArticleId: id });
            if (res.Ret === 200) {
              this.$message.success("删除成功！");
              let page_num = Math.ceil((this.total - 1) / this.PageSize);
              if (this.page_no > page_num) {
                this.page_no = page_num;
              }
              this.getList();
            }
          } else {
            const res = await raiInterface.roadshowEssencePublishAndCancel({ ArticleId: id });
            if (res.Ret === 200) {
              this.$message.success(value + "成功！");
              this.getList();
            }
          }
        })
        .catch(() => {
          this.$message({
            type: "info",
            message: `已取消${value}`,
          });
        });
    },
    //文章详情
    goDetail(row) {
      let { href } = this.$router.resolve({ name: "预览路演精华", query: { ArticleId: row.ArticleId } });
      window.open(href, "_blank");
    },
    //分页
    handleCurrentChange(page) {
      this.page_no = page;
      this.getList();
    },
    editReport(id, status) {
      this.$router.push({
        path: "/editRoadshow",
        query: { id },
      });
    },
    keyValueInpt() {
      this.page_no = 1;
      this.getList();
      this.init();
    },
    init() {
      this.industry = ""; //行业
      this.status = ""; //发布状态
      this.issueTime = ""; //时间
    },
    //table表头Pu/Uv自定义
    renderHeader(h, { column, $index }) {
      return h("div", { attrs: { style: "padding:0;" } }, [
        h("span", column.label),
        h("el-tooltip", { props: { placement: "top" } }, [
          h("p", { slot: "content", attrs: { style: "display:block;padding:5px 0;width:420px;" } }, "pv：报告被打开的次数，每次打开都计算一次（只统计有权限用户）"),
          h("p", { slot: "content", attrs: { style: "display:block;padding:5px 0;width:420px;" } }, "uv：访问报告的人数，每篇报告同一个人访问只计算一次（只统计有权限用户）"),
          h("el-button", { props: { icon: "el-icon-info" }, attrs: { style: "border:none;background:none" } }, ""),
        ]),
      ]);
    },
    //导出pv uv
    exportPvUv(id) {
      const url = process.env.API_ROOT + "/cygx/reportSelection/articleHistoryExport?ArticleId=" + id + "&Source=2&" + localStorage.getItem("auth") || "";
      return url;
    },
  },
  beforeRouteEnter(to, from, next) {
    if (from.path != "/editRoadshow") {
      sessionStorage.removeItem("roadshowEssenceBack");
    }
    next();
  },
  beforeRouteLeave(to, from, next) {
    let backData = {
      page_no: this.page_no,
      status: this.status, //状态
      issueTime: this.issueTime, //时间
      industry: this.industry,
      keyWord: this.keyWord,
    };
    sessionStorage.setItem("roadshowEssenceBack", JSON.stringify(backData));
    next();
  },
};
</script>
<style scoped lang="scss">
.container-essence {
  .top-box {
    display: flex;
    justify-content: space-between;
    .top-container {
      .el-select {
        width: 240px;
        margin-right: 20px;
      }
      .top-input {
        display: inline-block;
        width: 521px;
        margin-bottom: 20px;
      }
    }
  }
  .mx-datepicker {
    width: 230px !important;
    margin-right: 25px;
  }
  .pv-uv-download {
    display: flex;
    align-items: center;
    justify-content: center;
    img {
      width: 14px;
      height: 14px;
      margin-left: 10px;
    }
  }
}
</style>
